

//+------------------------------------------------------------------+
//|                      OM NAMAH SIVAY                              |
//|        OM NAMAH SIVAY              OM NAMAH SIVAY                |
//|    OM NAMAH SIVAY    OM NAMAH SIVAY    OM NAMAH SIVAY            |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, OM Corp."
#property link "http://www.jatinpruthvi.co.cc"

#include "Jatin_Symbol.mqh"
class MyPair
{
private:
	int symbol_size;
	string pair;

	int ADX_Period; // ADX Period
	int MA_Period;  // Moving Average Period
	double Adx_Min;
	int RVI_PERIOD;
	ENUM_TIMEFRAMES period; // variable to hold the current timeframe value
	MySymbolExpert Csymbol[3];
	int Symbol_Signal[3];
	int BBSorSSB;
	int rating;
	ENUM_ORDER_TYPE BBS[3];  // BUY BUY SELL ;  // BUY BUY SELL
	ENUM_ORDER_TYPE SSB[3]; // SELL SELL BUY
   //ENUM_ORDER_TYPE BBS[3] = { ORDER_TYPE_BUY, ORDER_TYPE_BUY, ORDER_TYPE_SELL };  // BUY BUY SELL ;  // BUY BUY SELL
	//ENUM_ORDER_TYPE SSB[3]= { ORDER_TYPE_SELL, ORDER_TYPE_SELL, ORDER_TYPE_BUY }; // SELL SELL BUY


public:
string EA_Symbols_Array[];
   void MyPair(){
    symbol_size = 0;
    pair = "";

	ADX_Period = 14; // ADX Period
	MA_Period = 10;  // Moving Average Period
	Adx_Min = 22.0;
	
	ArrayInitialize(BBS,-1);
   ArrayInitialize(SSB,-1);	
	 BBSorSSB = -1;
	 rating = 0;
   }
	
	void init(string reqPair, ENUM_TIMEFRAMES periods, int ADX_Periods, int MA_Periods, int Adx_Mins ,int nRVI_PERIOD)
	{
	ArrayFill(BBS,ORDER_TYPE_BUY, ORDER_TYPE_BUY, ORDER_TYPE_SELL );
	ArrayFill(SSB,ORDER_TYPE_SELL, ORDER_TYPE_SELL, ORDER_TYPE_BUY );
		ADX_Period = ADX_Periods; // ADX Period
		MA_Period = MA_Periods;   // Moving Average Period
		Adx_Min = Adx_Mins;
		period = periods;
		pair = reqPair;
		RVI_PERIOD = nRVI_PERIOD;
		symbol_size = StringSplit(reqPair, StringGetCharacter(";", 0), EA_Symbols_Array);
		doStart();
	}

	void doStart()
	{
		for (int i = 0; i < symbol_size; i++) {
			Csymbol[i].setSymbol(EA_Symbols_Array[i]);
			Csymbol[i].setPeriod(period);
			Csymbol[i].doInit(ADX_Period, MA_Period,RVI_PERIOD);
			Csymbol[i].setadxmin(Adx_Min); // sets the ADX miniumm value
		}
	}

	void processSignal()
	{
		for (int i = 0; i < symbol_size; i++) {
			Symbol_Signal[i] = Csymbol[i].getBuySellSignal();
		}
		prepareOrderSendType();
	}

	// BUY BUY SELL
	// SELL SELL BUY
	// 0 - nothing , 1-Buy , 2-Sell
	void prepareOrderSendType()
	{
		int bbs = 0, ssb = 0;
		for (int i = 0; i < symbol_size; i++) {
			if (Symbol_Signal[i] == BBS[i]) {
				bbs++;
			}
			if (Symbol_Signal[i] == SSB[i]) {
				ssb++;
			}
		}
		if (bbs < ssb) {
			BBSorSSB = 2; //placeSSB
			rating = ssb;
		}
		else if (bbs > ssb) {
			BBSorSSB = 1; //placeBBS
			rating = bbs;
		}
		else {
			BBSorSSB = -1;
			rating = 0;
		}

	}

	int getRating(){
		return rating;
	}
	int getBBSorSSB(){
		return BBSorSSB;
	}

	string getPair(){
		return pair;
	}

	double getTotalSpread(){
		double d = 0;
		for (int i = 0; i < symbol_size; i++) {
			double spread = SymbolInfoDouble(EA_Symbols_Array[i], SYMBOL_ASK) - SymbolInfoDouble(EA_Symbols_Array[i], SYMBOL_BID);
			d = d + spread;
		}
		return d;
	}

	void doUnunit(){
		for (int i = 0; i < symbol_size; i++) {
			Csymbol[i].doUninit();
		}
	}

};
	


